#ifndef _NALib_Header
#define _NALib_Header
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#define	FALSE		0
#ifndef TRUE
#define TRUE		!FALSE
#endif
#define BFSZ		1024
#define LBFSZ		8192
#define SEP			'/'
#define NA_HASH_SZ	9
#define	myfree(x)	{free(x);x=NULL;}
#define iseol(x)	(x == '\r' || x == '\n' || x == '\0')
#define issep(x)	(x == '\\' || x == '/')
#ifdef WIN32
#	define snprintf	_snprintf
#	define vsnprintf	_vsnprintf
#else
#	include <stdarg.h>
	int snprintf(char *buffer, unsigned int bfsz, const char *format, ...);
	int vsnprintf(char *buffer, unsigned int bfsz, const char *format, va_list arg);
#endif

int ncpy(char *dst, char *src, int len);
int ncat(char *dst, char *src, int len);
char *attach_path(char *dst, char *src, int len);
char *strip_eol(char *string);
char *stristr(char *string1, char *string2);

int s_stricmp(const char *string1, const char *string2);
#ifndef stricmp
#define stricmp s_stricmp
#endif

char *s_strlwr(char *string);
#ifndef strlwr
#define strlwr s_strlwr
#endif

int wild_match(char *text, char *wild);

#define iserror() (error[0] != '\0')
void set_error(char *message, ...);
char *get_error(void);
void clr_error(void);

typedef struct ini_setting { char label[BFSZ], value[BFSZ]; int ismulti; } ISet, *pISet;
typedef struct ini_list { char **values; int nvalues, nsize; } IList, *pIList;
typedef struct ini_struct { pIList list; pISet settings; int count; } Ini, *pIni;
pIni ini_init(pISet list);
int ini_load(pIni x, char *file);
char *ini_value_n(pIni x, int index, int count);
#define ini_value(x,y) ini_value_n(x,y,0)
void ini_free(pIni *x);

typedef struct log_file { FILE *fp; int level; } Log, *pLog;
enum { LOG_ERROR, LOG_INFO, LOG_DEBUG };
pLog log_open(char *file);
void log_setlvl(pLog x, int level);
void log_flush(pLog x);
void log_free(pLog *x);

char *oa_stripname(char *username, char *result, char *domain, int bfsz);
#endif
